#include <verifier-builtins.h>
#include <stdio.h>
#include <stdlib.h>

struct L {
	int data;
	struct L* next;
};

typedef struct L L;

int main(int argc, char** argv) {

	L* head = (L*)malloc(sizeof(L));
	
	// Creates 4 element single linked list
	L* node = head;
	int i;
	for (i = 0; i < 3; i++) {
		L* new_node = (L*)malloc(sizeof(L));
		node->next = new_node;
		node = new_node;
	}

	// List is cyclic
	node->next = head;

	// Deallocate list
	// BUG -> should run forewer -> cyclic list (double free error)
	while(node != NULL) {
		L* next_node = node->next;
		free(node);
		node = next_node;
	}

}
